<?php 

//namespace App\Controllers;

require WBDL_PLUGIN_DIR .'/App/Models/Bundle.php';

//use App\Models\Bundle;

if (!defined('ABSPATH')) exit; // Exit if accessed directly

class BundleController
{
    /**
     * Show the product attributes based on the id.
     * */
    public function getBundlesByProductID($productID)
    {
        $bundle = new Bundle();
        $results = $bundle->getBundlesByProductID($productID); 
        
        return $results;
    }

    /**
     * Get bundles by product ID, sorted by Qty Desc.
     * */
    public function getBundlesByProductIDSortByQtyDesc($productID)
    {
        
        $bundle = new Bundle();
        $results = $bundle->getBundlesByProductIDSortByQtyDesc($productID); 
        
        return $results;
    }

    /**
     * Remove bundles by product ID.
     * */
    public function deleteBundlesByProductID($productID){

        $bundle = new Bundle();
        $bundle->deleteBundlesByProductID($productID);

    }

    /**
     * Add bundles by product ID.
     * */
    public function addBundlesByProductID($productID)
    {   
       
        if(isset($_POST['bundleTitle']) && isset($_POST['productQty']) && $_POST['regularPrice'])
        {

            $this->deleteBundlesByProductID($productID);

            $new = array();
            $count = count( $_POST['bundleTitle'] );
        
            for ( $i = 0; $i < $count; $i++ ) {
                if ( $_POST['bundleTitle'][$i] != '' ) :

                    // Sanitizing inputs

                    $inputs['bundleTitle'][$i] = sanitize_text_field($_POST['bundleTitle'][$i]);
                    $inputs['imageUrl'][$i] = sanitize_url($_POST['imageUrl'][$i]);
                    $inputs['productQty'][$i] = sanitize_text_field($_POST['productQty'][$i]);
                    $inputs['salePrice'][$i] = sanitize_text_field($_POST['salePrice'][$i]);
                    $inputs['regularPrice'][$i] = sanitize_text_field($_POST['regularPrice'][$i]);
                    
                    if(isset($_POST['use_custom_variations'])) $inputs['use_custom_variations'][$i] = 'on';
                    else $inputs['use_custom_variations'][$i] = 'off';

                    $inputs['option1Name'][$i] = sanitize_text_field($_POST['option1Name'][$i]);
                    $inputs['option1Val'][$i] = sanitize_text_field($_POST['option1Val'][$i]);
                    $inputs['option2Name'][$i] = sanitize_text_field($_POST['option2Name'][$i]);
                    $inputs['option2Val'][$i] = sanitize_text_field($_POST['option2Val'][$i]);
                    $inputs['message'][$i] = sanitize_text_field($_POST['message'][$i]);
                    $inputs['discountRule'][$i] = sanitize_text_field($_POST['discountRule'][$i]);
                    $inputs['messageEffect'][$i] = sanitize_text_field($_POST['messageEffect'][$i]);
                    

                    if( ($_POST['preselectedOfferID'] != "off") && ($i == $_POST['preselectedOfferID']) ){
                        $inputs['preselectedOffer'][$i] = 'on';
                    }
                    else $inputs['preselectedOffer'][$i] = 'off';

                    // Building the new array

                    $inputs['bundleTitle'][$i] = stripslashes( strip_tags( $inputs['bundleTitle'][$i] ) );
                    $inputs['imageUrl'][$i] = stripslashes( strip_tags( $inputs['imageUrl'][$i] ) );
                    $inputs['productQty'][$i] = stripslashes( $inputs['productQty'][$i] ); 
                    $inputs['salePrice'][$i] = stripslashes( $inputs['salePrice'][$i] ); 
                    $inputs['regularPrice'][$i] = stripslashes( $inputs['regularPrice'][$i] );
                    $inputs['use_custom_variations'][$i] = stripslashes( $inputs['use_custom_variations'][$i] );
                    $inputs['option1Name'][$i] = stripslashes( $inputs['option1Name'][$i] ); 
                    $inputs['option1Val'][$i] = stripslashes( $inputs['option1Val'][$i] );
                    $inputs['option2Name'][$i] = stripslashes( $inputs['option2Name'][$i] );
                    $inputs['option2Val'][$i] = stripslashes( $inputs['option2Val'][$i] );
                    $inputs['message'][$i] = stripslashes( $inputs['message'][$i] );
                    $inputs['discountRule'][$i] = stripslashes( $inputs['discountRule'][$i] );
                    $inputs['preselectedOffer'][$i] = $inputs['preselectedOffer'][$i];
                    $inputs['messageEffect'][$i] = stripslashes( $inputs['messageEffect'][$i] );

                endif;
            }

            $bundle = new Bundle();
            
            for( $i = 0; $i < $count; $i++ ) {

                if ( $inputs['bundleTitle'][$i] != '' ) :
                    $bundle->addNewBundle($productID, $inputs['bundleTitle'][$i], $inputs['imageUrl'][$i], $inputs['productQty'][$i], $inputs['salePrice'][$i], $inputs['regularPrice'][$i], $inputs['use_custom_variations'][$i], $inputs['option1Name'][$i], $inputs['option1Val'][$i], $inputs['option2Name'][$i], $inputs['option2Val'][$i], $inputs['message'][$i], $inputs['discountRule'][$i], $inputs['preselectedOffer'][$i], $inputs['messageEffect'][$i]);
                endif;
            }
        }

    }

    public function getVariationsByBundleTitle($productID, $bundleTitle){

        $bundle = new Bundle();
        return $bundle ->getVariationsByBundleTitle($productID, $bundleTitle);

    }
}