<?php 

//namespace App\Models;

class Bundle {

	protected $id;
    protected $productID;
    protected $bundleMetaID;
    protected $sizeMetaID;
    protected $title;
    protected $image;
    protected $productsNB;
    protected $salePrice;
    protected $regularPrice;
    protected $option1Name;
    protected $option1Value;
    protected $option2Name;
    protected $option2Value;
    protected $message;
    protected $discountRule;
    protected $preselectedOffer;
    protected $messageEffect;


    // Constructor
    /*function __construct($productID,$bundleMetaID,$sizeMetaID,$title,$image,$productsNB,$salePrice,$regularPrice,$option1Name,$option1Value,$option2Name,$option2Value,$message,$discountRule,$preselectedOffer,$messageEffect){

        // This is initializing the class properties
        $this->productID = $productID;
        $this->bundleMetaID = $bundleMetaID;
        $this->sizeMetaID = $sizeMetaID;
        $this->title = $title;
        $this->image = $image;
        $this->productsNB = $productsNB;
        $this->salePrice = $salePrice;
        $this->regularPrice = $regularPrice;
        $this->option1Name = $option1Name;
        $this->option1Value = $option1Value;
        $this->option2Name = $option2Name;
        $this->option2Value = $option2Value;
        $this->message = $message;
        $this->discountRule = $discountRule;
        $this->preselectedOffer = $preselectedOffer;
        $this->messageEffect = $messageEffect;

    }*/


	// GET METHODS
    public function getId()
    {
        return $this->id;
    }

    public function getProductID()
    {
        return $this->productID;
    }

    public function getBundleMetaID()
    {
        return $this->bundleMetaID;
    }

    public function getSizeMetaID()
    {
        return $this->sizeMetaID;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getProductsNB()
    {
        return $this->productsNB;
    }

    public function getSalePrice()
    {
        return $this->salePrice;
    }

    public function getRegularPrice()
    {
        return $this->regularPrice;
    }

    public function getOption1Name()
    {
        return $this->option1Name;
    }

    public function getOption1Value()
    {
        return $this->option1Value;
    }

    public function getOption2Name()
    {
        return $this->option2Name;
    }

    public function getOption2Value()
    {
        return $this->option2Value;
    }

    public function getMessage()
    {
        return $this->message;
    }

    public function getDiscountRule()
    {
        return $this->discountRule;
    }

    public function getPreselectedOffer()
    {
        return $this->preselectedOffer;
    }

	public function getMessageEffect()
    {
        return $this->messageEffect;
    }


    /*
     * SET METHODS
     */

    public function setProductID(string $productID)
    {
        $this->productID = $productID;
    }

    public function setBundleMetaID( string $bundleMetaID)
    {
        $this->bundleMetaID = $bundleMetaID;
    }

    public function setSizeMetaID(string $sizeMetaID)
    {
        $this->sizeMetaID = $sizeMetaID;
    }

    public function setTitle(string $title)
    {
        $this->title = $title;
    }

    public function setImage(string $image)
    {
        $this->image = $image;
    }

    public function setProductsNB(int $productsNB)
    {
        $this->productsNB = $productsNB;
    }

    public function setSalePrice(float $salePrice)
    {
        $this->salePrice = $salePrice;
    }

    public function setRegularPrice(float $regularPrice)
    {
        $this->regularPrice = $regularPrice;
    }

    public function setOption1Name(string $option1Name)
    {
        $this->option1Name = $option1Name;
    }

    public function setOption1Value(string $option1Value)
    {
        $this->option1Value = $option1Value;
    }

    public function setOption2Name(string $option2Name)
    {
        $this->option2Name = $option2Name;
    }

    public function setOption2Value(string $option2Value)
    {
        $this->option2Value = $option2Value;
    }

    public function setMessage(string $message)
    {
        $this->message = $message;
    }

    public function setDiscountRule(string $discountRule)
    {
        $this->discountRule = $discountRule;
    }

    public function setPreselectedOffer(string $preselectedOffer)
    {
        $this->preselectedOffer = $preselectedOffer;
    }

	public function setMessageEffect(string $messageEffect)
    {
        $this->messageEffect = $messageEffect;
    }


	/*
	 * CRUD OPERATIONS
	 */

    public function addNewBundle($productID,$title,$image,$productsNB,$salePrice,$regularPrice,$useCustomVariations,$option1Name,$option1Value,$option2Name,$option2Value,$message,$discountRule,$preselectedOffer,$messageEffect){
        
        global $wpdb;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix . "wbdl_bundle_data";

        $wpdb->insert( 
            $table_name, 
            array( 
                'product_id' => $productID, 
                'bundle_title' => $title, 
                'image_url' => $image, 
                'number_of_products' => $productsNB, 
                'sale_price' => $salePrice, 
                'regular_price' => $regularPrice, 
                'use_custom_variations' => $useCustomVariations,
                'option1_name' => $option1Name, 
                'option1_value' => $option1Value, 
                'option2_name' => $option2Name, 
                'option2_value' => $option2Value, 
                'message' => $message, 
                'discount_rule' => $discountRule, 
                'preselected_offer' => $preselectedOffer, 
                'message_effect' => $messageEffect, 
            ) 
        );
    }

    public function getBundlesByProductID($productID){

    	global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix . "wbdl_bundle_data";
        $query = $wpdb->prepare( "SELECT * FROM $table_name WHERE product_id = %s", $productID );

		return $wpdb->get_results($query);
    }

    public function getBundlesByProductIDSortByQtyDesc($productID){

        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix . "wbdl_bundle_data";
        $query = $wpdb->prepare( "SELECT * FROM $table_name WHERE product_id = %s ORDER BY number_of_products DESC", $productID );
        
        return $wpdb->get_results($query);
    }

    public function updateBundlesByProductID($productID, $bundle){

        deleteBundlesByProductID($productID);
        foreach ($bundle as $key => $value) {
            addNewBundle($productID, $bundle);
        }
    }

    public function deleteBundlesByProductID($productID){

        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix . "wbdl_bundle_data";
        $wpdb->delete( $table_name, array( 'product_id' => $productID) );

    }

    public function getVariationsByBundleTitle(int $productID, $bundleTitle){

        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        $table_name = $wpdb->prefix . "wbdl_bundle_data";
        $query = $wpdb->prepare( "SELECT * FROM $table_name WHERE bundle_title = %s AND product_id = %s", array($bundleTitle,$productID) );

        return $wpdb->get_results($query);
    }

}
