<?php 

//namespace App\Models;

class DBTables {

	/*
	 * Class for creating tables into Database
	 */

    public static $wbdl_db_version = '1.0';

    public static function createDbTables(){
        
        global $wpdb;

        $installedVersion = get_option( 'woobundles_db_version' );

        if($installedVersion){
            if ( $installedVersion != self::$wbdl_db_version ) {
                self::createBundleTable($wpdb);
                self::createSettingsTable($wpdb);
                update_option( 'woobundles_db_version', self::$wbdl_db_version );
            }
        }
        else{
            self::createBundleTable($wpdb);
            self::createSettingsTable($wpdb);
            add_option( 'woobundles_db_version', self::$wbdl_db_version );
            self::initializeSettings($wpdb);
            
        }

    }


    public static function createBundleTable($wpdb){
		
		$charset_collate = $wpdb->get_charset_collate();

		$table_name = $wpdb->prefix . "wbdl_bundle_data";
    	
    	$sql1="CREATE TABLE IF NOT EXISTS $table_name ( 
        id mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
        product_id varchar(36) DEFAULT '' NOT NULL,
        bundle_title varchar(255) DEFAULT '' NOT NULL,
        image_url varchar(2048) DEFAULT '' NOT NULL,
        number_of_products varchar(36) DEFAULT '1' NOT NULL,
        sale_price varchar(36) DEFAULT '' NOT NULL,
        regular_price varchar(36) DEFAULT '' NOT NULL,
        use_custom_variations varchar(10) DEFAULT 'off' NOT NULL,
        option1_name varchar(36) DEFAULT '' NOT NULL,
        option1_value varchar(36) DEFAULT '' NOT NULL,
        option2_name varchar(36) DEFAULT '' NOT NULL,
        option2_value varchar(36) DEFAULT '' NOT NULL,
        message varchar(255) DEFAULT '' NOT NULL,
        discount_rule varchar(255) DEFAULT '' NOT NULL,
        preselected_offer varchar(36) DEFAULT 'off' NOT NULL,
        message_effect varchar(36) DEFAULT '' NOT NULL,
        PRIMARY KEY (id)) $charset_collate;";

        require_once ABSPATH . 'wp-admin/includes/upgrade.php';
    	dbDelta($sql1);
    }

    public static function createSettingsTable($wpdb){
        
        $charset_collate = $wpdb->get_charset_collate();

        $table_name = $wpdb->prefix . "wbdl_bundle_settings";
        
        $sql1="CREATE TABLE IF NOT EXISTS $table_name ( 
        `id` int(11) NOT NULL AUTO_INCREMENT,
        `design` varchar(220) DEFAULT NULL,
        `border_color` varchar(220) DEFAULT NULL,
        `background_color` varchar(20) DEFAULT NULL,
        `background_color_active` varchar(20) DEFAULT NULL,
        `bundles_title` varchar(220) DEFAULT NULL,
        `title_show` varchar(220) DEFAULT NULL,
        PRIMARY KEY(id)) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql1);

    }

    public static function initializeSettings($wpdb){

        $table_name = $wpdb->prefix . "wbdl_bundle_settings";

        $wpdb->insert( $table_name, array('id' =>'1', 'design' =>'classic', 'border_color'=>'#565add', 'background_color'=>'#ffffff00', 'background_color_active'=>'#fafbff', 'bundles_title'=>'Select your offer', 'title_show'=> 'off'));
    }


}
