<?php 

// use App\Controllers\BundleController;
// use App\Models\Settings;

require "update-cart-price.php";
require "cart-page-data.php";

if (!defined('ABSPATH')) exit; // Exit if accessed directly


/**
 * @function Ajax Add To Cart when native variations option is selected
 */

add_action( 'wp_ajax_wbdl_ajax_add_to_cart', 'wbdl_ajax_add_to_cart' );
add_action('wp_ajax_nopriv_wbdl_ajax_add_to_cart', 'wbdl_ajax_add_to_cart');

function wbdl_ajax_add_to_cart() {

	// Get the bundle's data from Ajax
  	
  	// Get Product infos
  	$productID = apply_filters('woocommerce_add_to_cart_product_id', absint(sanitize_text_field($_POST['wbdl_product_id'])));
    $productsNumber = empty( $_POST['wbdl_products_num'] ) ? 1 : wc_stock_amount(sanitize_text_field($_POST['wbdl_products_num']));
    $productStatus = get_post_status($productID);
    $passedValidation = apply_filters('woocommerce_add_to_cart_validation', true, $productID, $productsNumber);
    $qty = isset( $_POST['wbdl_product_quantity'] ) ? sanitize_text_field($_POST['wbdl_product_quantity']) : 1;
    //$wbdl_variation_id = absint($_POST['wbdl_variation_id']);
    
    // Get Bundles infos
    $bundleTitle = isset( $_POST ['wbdl_bundle_title'] ) ? sanitize_text_field ($_POST ['wbdl_bundle_title'] ): "" ;
    $bundleImage = isset( $_POST ['wbdl_bundle_image'] ) ? sanitize_text_field ($_POST ['wbdl_bundle_image'] ): "" ;

	// Get the product object
	$product = wc_get_product( $productID );

	//$productSalePrice = $product->get_sale_price();

	if($product->is_type('variable')){
		
	}
	else{ // Simple product
		// Add custom meta data to the product
		$cart_item_meta = wbdl_add_cart_item_data($cart_item_meta, $productID, $bundleTitle, $bundleImage, 0, 0, 'off', NULL);

		$qty = $qty * $productsNumber;
		
		if ($passedValidation && 'publish' === $productStatus && WC()->cart->add_to_cart($productID, $qty, $variationID, NULL, $cart_item_meta)) {
			
			wbdl_update_all_custom_data_price_in_cart();
			do_action('woocommerce_ajax_added_to_cart', $productID);
			if ('yes' === get_option('woocommerce_cart_redirect_after_add')) {
				wc_add_to_cart_message(array($productID => 1), true);
			}
			WC_AJAX :: get_refreshed_fragments();

		}
		else{
			$response = array(
				'error' => true,
				'message' => 'Validation error. Please make sure the product is published and available for purchase.',
				'product_url' => apply_filters('woocommerce_cart_redirect_after_error', get_permalink($productID), $productID));
			echo wp_send_json($response);
		}
	}
	wp_die();

}
