<?php 

/**
 * Admin view of bundles on product pages
 */

// use App\Controllers\BundleController;
// use App\Models\Settings;


/*
 * 1. Add meta boxes on the product admin page
 */

add_action('admin_init', 'wbdl_add_meta_boxes', 2);

function wbdl_add_meta_boxes() {
	add_meta_box( 'wbdl-group', 'Create Offers & Bundles', 'wbdl_repeatable_meta_box_display', 'product', 'normal', 'default');
}

/*
 * 2. Display bundle form on the admin product page
 */

function wbdl_repeatable_meta_box_display() {

	$bundleController = new BundleController();
	$settings = Settings::getSettings();
	$i=0;
    global $post;

    $wbdl_data_group = get_post_meta($post->ID, 'customdata_group', true);
    wp_nonce_field( 'gpm_repeatable_meta_box_nonce', 'gpm_repeatable_meta_box_nonce' );
	
?>

	
  	<form name="wbdl_bundle_creation_form" action="" method="post">
	<div class="over">
		<input type="hidden" name="preselectedOfferID" value="off">
		<table id="repeatable-fieldset-one" width="100%">
			<tbody>

			<?php 
			$results = $bundleController->getBundlesByProductID(get_the_ID());
			$product = wc_get_product( get_the_ID() );
			$useCustomVariations = 'off';
			if($results) :
				$useCustomVariations = $results[0]->use_custom_variations;
				// Show the colums titles
				?>

				<tr>
					<th>Offer Title *</th>
					<th>Image URL (PRO Feature)</th>
					<th>Products Quantity *</th>
					<th>Actual/Sale Price *</th>
					<th>Regular Price (optional)</th>
					
					<th class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display:none;';?>">Custom Option 1 Name (PRO Feature)</th>
					<th class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display:none;';?>">Custom Option 1 Values Seprated by "|" (PRO Feature)</th>
					<th class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display:none;';?>">Custom Option 2 Name (PRO Feature)</th>
					<th class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display:none;';?>">Custom Option 2 Values Seprated by "|" (PRO Feature)</th>
					
					<th>Message (optional)</th>
					<th>Discount Rule (optional)</th>
					<th>Preselected (PRO Feature)</th>
					<th>Effect (PRO Feature)</th>
				</tr>

				<?php
				// Prefill the form with bundle data from the database
				foreach ( $results as $row ) {
					
				?>

				<tr name="bundleInfo">
					<td>
						<input type="hidden" name="productID" value="<?php echo get_the_ID(); ?>">
						<input class="wbdl_bundle_title" type="text"  placeholder="Ex: 2 Tshirts + 1 Free" name="bundleTitle[]" value="<?php if($row->bundle_title!= '') echo esc_attr( $row->bundle_title ); ?>" />  
					</td> 
					<td>
						<input type="text" name="imageUrl[]" class="thmbnail_url" placeholder="Ex: https://yourdomain.com/path-to-image" value="<?php if($row->image_url != '') echo esc_attr( $row->image_url ); ?>" disabled>
					</td>
					<td>
						<input class="wbdl_product_qty" type="number" min="1" placeholder="Ex: 3"  name="productQty[]" value="<?php if( $row->number_of_products != '') echo esc_attr( $row->number_of_products ); ?>"/>
					</td>
					<td>
						<input class="wbdl_sale_price" type="number" step="0.01" min="0" placeholder="Ex: 14.99" name="salePrice[]" value="<?php if($row->sale_price != '') echo esc_attr( $row->sale_price ); ?>"/>
					</td>
					<td>
						<input class="wbdl_regular_price" type="number" step="0.01" min="0" placeholder="Ex: 19.99" name="regularPrice[]" value="<?php if($row->regular_price != '') echo esc_attr( $row->regular_price ); ?>"/>
					</td>

					<td class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display: none;'; ?>">
						<input type="text" placeholder="Ex: Color"  name="option1Name[]" value="<?php if( $row->option1_name != '') echo esc_attr( $row->option1_name ); ?>" disabled/>
					</td>
					<td class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display: none;'; ?>">
						<input type="text" placeholder="Ex: Black,Red,Blue"  name="option1Val[]" value="<?php if($row->option1_value != '') echo esc_attr( $row->option1_value ); ?>" disabled/>
					</td>
					<td class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display: none;'; ?>">
						<input type="text" placeholder="Ex: Size" name="option2Name[]" value="<?php if($row->option2_name != '') echo esc_attr( $row->option2_name ); ?>" disabled/>
					</td>
					<td class='wbdl_custom_options' style="<?php if($useCustomVariations == 'off') echo 'display: none;'; ?>">
						<input type="text" placeholder="Ex: Small,Large,XL"  name="option2Val[]" value="<?php if($row->option2_value != '') echo esc_attr( $row->option2_value ); ?>" disabled/>
					</td>
					
					<td>
						<input type="text" placeholder="Ex: Best seller!" name="message[]" value="<?php if($row->message != '') echo esc_attr( $row->message ); ?>"/>
					</td>
					<td>
						<input type="text" placeholder="Ex: Save 20% with this offer" name="discountRule[]" value="<?php if($row->discount_rule != '') echo esc_attr( $row->discount_rule ); ?>"/>
					</td>
					<td>			
						<div class="custom-selected">
							<input type="checkbox"  name="preselectedOffer[]" class="preselectedOffer" <?php if($row->preselected_offer == "on"){ echo "checked"; } ?> disabled>
						</div>
					</td>
					<td>
						<select name="messageEffect[]" disabled>
							<option value="0">Select</option>
							<option value="blinking" <?php if($row->message_effect){ echo "selected"; } ?>>Blinking</option>
						</select>
					</td>
					<td width="15%">
						<a class="button removel remove-row" href="#1">Remove</a>
					</td>
				</tr>
	    		<?php  
				} 
    		else :
    		// show a blank one
    		?>

    			<tr>
					<th>Bundle Title *</th>
					<th>Image URL (PRO Feature)</th>
					<th>Products Quantity *</th>
					<th>Bundle Price *</th>
					<th>Bundle Regular Price (optional)</th>
					
					<th class='wbdl_custom_options' style="display: none;">Custom Option 1 Name (PRO Feature)</th>
					<th class='wbdl_custom_options' style="display: none;">Custom Option 1 Values Seprated by "|" (PRO Feature)</th>
					<th class='wbdl_custom_options' style="display: none;">Custom Option 2 Name (PRO Feature)</th>
					<th class='wbdl_custom_options' style="display: none;">Custom Option 2 Values Seprated by "|" (PRO Feature)</th>
					
					<th>Message (optional)</th>
					<th>Discount Rule (optional)</th>
					<th>Preselected Offer (PRO Feature)</th>
					<th>Message Effect (PRO Feature)</th>
				</tr>

    			<tr name="bundleInfo">
					<td> 
						<input type="hidden" name="productID" value="<?php echo get_the_ID(); ?>">
						<input class="wbdl_bundle_title" type="text" placeholder="Ex: 2 Tshirts + 1 Free" title="Title" name="bundleTitle[]" /> 
					</td>
					<td>
    					<input type="text" name="imageUrl[]" class="thmbnail_url" placeholder="Ex: https://yourdomain.com/path-to-image" disabled />
    				</td>
					<td> 
						<input class="wbdl_product_qty" type="number" name="productQty[]" min="1" placeholder="Ex: 3" />
					</td>
					<td>
						<input class="wbdl_sale_price" type="number" step="0.01" min="0"  placeholder="Ex: 14.99" title="salePrice" name="salePrice[]"  />
					</td>
					<td>
						<input class="wbdl_regular_price" type="number" step="0.01" min="0"  placeholder="Ex: 19.99" title="regularPrice" name="regularPrice[]" />
					</td>
					<td class='wbdl_custom_options' style="display: none;">
						<input type="text" placeholder="Ex: Color" title="option1Name" name="option1Name[]" disabled />
					</td>
					<td class='wbdl_custom_options' style="display: none;">
						<input type="text" placeholder="Ex: Black,Red,Blue" title="option1Val" name="option1Val[]" disabled />
					</td>
					<td class='wbdl_custom_options' style="display: none;">
						<input type="text" placeholder="Ex: Size" title="option2Name" name="option2Name[]" disabled />
					</td>
					<td class='wbdl_custom_options' style="display: none;">
						<input type="text" placeholder="Ex: Small,Large,XL" title="option2Val" name="option2Val[]" disabled/>
					</td>
					<td>
						<input type="text" placeholder="Ex: Best seller!" title="message" name="message[]" />
					</td>
					<td>
						<input type="text" placeholder="Ex: Save 20% with this offer" title="discountRule" name="discountRule[]" />
					</td>
					<td>
						<div class="custom-selected">
							<input type="checkbox" class="preselectedOffer"  name="preselectedOffer[]" disabled>
						</div>
					</td>
					<td>
						<select name="messageEffect[]" disabled>
							<option value="0">Select</option>
							<option value="blinking">Blinking</option>
						</select>
					</td>
					<td>
						<a class="button removel cmb-remove-row-button button-disabled" href="#">Remove</a>
					</td>
				</tr>
    		<?php endif; ?>
			</tbody>
		</table>
	</div>
	<div style="margin-top: 20px; margin-bottom: 20px;">
		<input id="wbdl_save_bundle" class="admin-panel-submit" type="submit" name="submit" value="Save Offers">
		<a id="add-row" class="button add-another" data-role="button" data-inline="true" href="#">+ Add Offer</a>
		<span class='use_custom_var'>
			<label>Use custom variations </label>
                <label class="switch">
                <input type="checkbox" id="togBtn" name="use_custom_variations" <?php if($useCustomVariations == 'on') echo 'checked'; ?>>
                <div class="slider round"> </div>
            </label>
        </span>
	</div>
	</form>


	<script type="text/javascript">
		jQuery(document).ready(function( $ ){
			var bname ='';
			var postID = <?php echo get_the_ID(); ?>
			
			$('#add-row' ).on('click', function() {
				var _preC = jQuery('#repeatable-fieldset-one tbody>tr:last').find('input[name=preselected_offer]').val()
				_preC = parseInt(_preC)+1;
				var useCustomVar = $(document).find('input[name="use_custom_variations"]').prop("checked");
				var data = '<tr name="bundleInfo"><input type="hidden" name="productID" value="'+postID+'"><input type="hidden"  name="preselected_count[]" value="'+_preC+'" ><td><input type="text" placeholder="Ex: 2 Tshirts + 1 Free" class="wbdl_bundle_title" title="bundleTitle" name="bundleTitle[]" /> </td><td><input type="text" placeholder="Ex: https://yourdomain.com/path-to-image" name="imageUrl[]" class="thmbnail_url"></td><td><input type="number" placeholder="Ex: 3" title="productQty" class="wbdl_product_qty" name="productQty[]" /></td><td><input class="wbdl_sale_price" type="number" step="0.01" min="0"  placeholder="Ex: 14.99" title="salePrice" name="salePrice[]" /></td><td><input type="number" step="0.01" min="0"  placeholder="Ex: 19.99" title="regularPrice" class="wbdl_regular_price" name="regularPrice[]" /></td><td class="wbdl_custom_options"><input type="text" placeholder="Ex: Color" title="option1Name" name="option1Name[]"/></td><td class="wbdl_custom_options"><input type="text" placeholder="Ex: Black,Red,Blue" title="option1Val" name="option1Val[]"/></td><td class="wbdl_custom_options"><input type="text" placeholder="Ex: Size" title="option2Name" name="option2Name[]"/></td><td class="wbdl_custom_options"><input type="text" placeholder="Ex: Small,Large,XL" title="option2Val" name="option2Val[]"/></td><td><input type="text" placeholder="Ex: Best seller!" title="message" name="message[]" /></td><td><input type="text" placeholder="Ex: Save 20% with this offer" title="discountRule" name="discountRule[]" /></td><td><div class="custom-selected"><input type="checkbox" class="preselectedOffer" name="preselectedOffer[]" disabled> 		</div></td><td><select name="messageEffect[]" disabled><option value="0">Select</option><option value="blinking">Blinking</option></select></td><td><a class="button removel remove-row" href="#">Remove</a></td></tr>';
				
			    
				var row = $(data).clone(true);
				row.insertAfter( '#repeatable-fieldset-one tbody>tr:last' );
				if (useCustomVar == true) {
			        jQuery(document).find('.wbdl_custom_options').show();
			    } else {
			        jQuery(document).find('.wbdl_custom_options').hide();
			    }
				return false;
			});

			$(document).on('click','.remove-row', function() {

				$(this).parents('tr').remove();
				
				if($('#repeatable-fieldset-one').find('tr').length == 1) {
					$(document).find('#add-row').trigger('click');
				}
				return false;
			});
		});
		
  	</script>

<?php
}

// If the user clicks on submit button

if (isset($_POST['submit'])) {

	if ( ! isset( $_POST['gpm_repeatable_meta_box_nonce'] ) )
	        return;

	$bundleController = new BundleController();
	$bundleController->addBundlesByProductID($_POST['productID']);

	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
        return;

    //if (!current_user_can('edit_post', $post_id)) return;

	
}


