<?php 

// use App\Controllers\BundleController;
// use App\Models\Settings;


/*
 *	Build the Woobundles widget on product pages
 */

add_action( 'woocommerce_before_add_to_cart_button', 'wbdl_add_widget_before_add_to_cart' );

function wbdl_add_widget_before_add_to_cart( ) {
		
	global $post;
	$gpminvoice_group = get_post_meta($post->ID, 'customdata_group', true);

	if ( get_post_type( $post ) === 'product' && ! is_a($product, 'WC_Product') ){

		$productID = get_the_ID();
    	$product = wc_get_product( $productID );

    	// Initialize the controllers
		$bundleController = new BundleController();

    	// Get the plugin's settings
 		$settings = Settings::getSettings();
 		
 		// Get all the bundles for the current product
		$availableBundles = $bundleController->getBundlesByProductID($productID);

		if($product->is_type('simple')){
			if ( $availableBundles ){
			// Hide the default variations form ?>
				<style>
					table.variations {
				     display: none !important; 
					}
				</style>
			<?php
				$useCustomVariations = $availableBundles[0]->use_custom_variations;
		 	?>

			<table class="variations design3" cellspacing="0">

			    <style>
			        .custom-bundle-three.active {border-color:<?php esc_html_e($settings[0]->border_color); ?> !important }
			        .custom-bundle-three.active .bundle-message-blink-three {color:<?php esc_html_e($settings[0]->border_color); ?> !important}
			        .custom-bundle-three.active .bundle-message-not-blink-three {color:<?php esc_html_e($settings[0]->border_color); ?> !important}
			        .custom-bundle-three .bundle-price-three{color:<?php esc_html_e($settings[0]->border_color); ?> !important}
			        .custom-bundle-three span.bundle-variation select {border-color:<?php esc_html_e($settings[0]->border_color); ?> !important}
			        .custom-bundle-three .radio-button input[type=radio]:checked:before{background:<?php esc_html_e($settings[0]->border_color); ?> !important}
			        .custom-bundle-three {background:<?php esc_html_e($settings[0]->background_color); ?> !important}
				    .custom-bundle-three.active {background:<?php esc_html_e($settings[0]->background_color_active); ?> !important}
			    </style>

				<tbody>
			    	<input type="hidden" class="productType" name="wbdl_product_type" value="<?php esc_attr_e($product->get_type()); ?>" >
			    	<input type="hidden" class="Btitle" name="bundle_title" >
			    	<input type="hidden" class="productID" name="product_id" value="<?php esc_attr_e($productID); ?>">
			    	<input type="hidden" class="Bprice" name="bundle_hidden_price" >
			    	<input type="hidden" class="Pimage" name="bundle_hidden_image" value="" >
			    	<input type="hidden" class="Cvar" name="use_custom_variations" value="<?php esc_attr_e($useCustomVariations); ?>" >
	
						<?php if($settings[0]->title_show == 'on'){  ?> <div class="custom-title"><?php esc_html_e($settings[0]->bundles_title); ?></div> <?php } ?>

	     			<div class="custom-design-three">

	     				<?php 
						foreach ($availableBundles as $result) {  
						
						?>

						<div class="custom-bundle-three" products-number="<?php esc_attr_e( $result->number_of_products); ?>">

						    <span class="radio-button <?php if($result->preselected_offer == "on") echo 'active';?>">
						      <input type="radio" class="radio_select" name="bundle_select" value="1" <?php if($result->preselected_offer == "on") echo "checked"; ?> > 
	              			</span>

	              			<?php if($result->image_url){ ?>

	          				<img class="img_thumbnail" name="bundle_image" width="150px" src="<?php esc_url($result->image_url); ?>">
	          				<?php } ?>
	              
		              		<div class="message-with-three">

	              				<?php if($result->message_effect == 'blinking'){ ?>
				    			<p class="bundle-message-blink-three"><?php esc_html_e($result->message); ?></p>
	    						<?php } else { ?>
    							<p class="bundle-message-not-blink-three"><?php esc_html_e($result->message); ?></p>
	    						<?php } ?>

	    						<h5 class="b_title" data-number="<?php esc_html_e($result->number_of_products);?>" data-title="<?php esc_attr_e($result->bundle_title);?>"><?php esc_html_e($result->bundle_title);?></h5>

				    			<div class="wbdl-price-three">

			    					<?php 

									if($result->regular_price){
	    								$regularPrice = Strip_tags(wc_price($result->regular_price));
	    							?>

									<span class="bundle-cprice-three" name="bundle_cprice" value="<?php esc_attr_e($regularPrice); ?>"><?php esc_html_e($regularPrice); ?></span>

									<?php }

									if($result->sale_price){
			    							
			    							$salePrice = Strip_tags(wc_price($result->sale_price));
			    					?>
										<span class="bundle-price-three" name="bundle_price" value="<?php esc_attr_e($salePrice);?>" ><?php esc_html_e($salePrice);?></span>

									<?php }
									
									?>
								</div>

									<?php
			    						// Calculate the % discount
	    							 
	    							 if($result->discount_rule){ 
										
										$discount = $result->regular_price - $result->sale_price;
		    							$percentChange = (1 - $result->sale_price / $result->regular_price ) * 100;

				    					$discount = wc_price($discount);
				    					$percent =number_format($percentChange);
				    					$str = str_replace("($)",$discount,$result->discount_rule);
				    					$str = str_replace("(%)",$percent.'%',$str);
	    							 ?>
					    				<span class="discount-rule-three">
					    				    <?php echo $str; ?>
					    				</span>
									<?php } ?>

    				    	</div>
    					</div>
					<?php  } ?>
					</div>
				</tbody>
			</table>
		<?php }

		}

	}
 } 
